
//  !hpf$ processors q(2, 3)
//
//  !hpf$ template s(14, 100)
//  !hpf$ distribute s(block, cyclic(5)) onto q
//
//  logical m(6, 35)
//  !hpf$ align m(i, j) with s(2 * i, 90 - 2 * j) 
//  integer a(6, 35)
//  !hpf$ align a(:, :) with m(:, :)
//
//  do i = 1, 6
//    do j = 1, 35
//      m(i, j) = .false.
//      if(j < 13) then
//        a(i, j) = i
//      else
//        a(i, j) = 1
//      endif
//    enddo
//  enddo
//
//  m(1, 6)  = .true.
//  m(1, 12) = .true.
//  m(1, 25) = .true.
//
//  m(3, 35) = .true.
//
//  m(4, 1)  = .true.
//  m(4, 2)  = .true.
//
//  do j = 1, 35
//    m(5, j) = .true.
//  enddo
//
//  print "(6i4)", sum(a, dim = 2)
//  print "(6i4)", sum(a, dim = 2, mask = m)
//end


#include <stdio.h>
#include "ad++.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

//  !hpf$ processors q(2, 3)
//
//  !hpf$ template s(14, 100)
//  !hpf$ distribute s(block, cyclic(5)) onto q
//
//  logical m(6, 35)
//  !hpf$ align m(i, j) with s(2 * i, 90 - 2 * j) 
//  integer a(6, 35)
//  !hpf$ align a(:, :) with m(:, :)

  Procs2 q(2, 3) ;

  BlockRange s1(14,  q.dim(0)) ;
  //BlockRange s2(100, CyclicRange(20, q.dim(1))) ;
  BlockCyclicRange s2(100, q.dim(1), 5) ;

  Range x = s1.subrng(6, 1, 2) ;
  Range y = s2.subrng(35, 87, -2) ;

  Array2<int> m(x, y, q) ;
  Array2<int> a(x, y, q) ;
  Array2<float> b(x, y, q) ;
  Array2<double> c(x, y, q) ;

//  do i = 1, 6
//    do j = 1, 35
//      m(i, j) = .false.
//      if(j < 13) then
//        a(i, j) = i
//      else
//        a(i, j) = 1
//      endif
//    enddo
//  enddo

  ON(q) {
    Index i(x) ;
    Index j(y) ;

    OVERALL(i) {
      OVERALL(j) {
        m(i, j) = 0 ;
//        if(j < 12)
//          a(i, j) = i ;
//        else
//          a(i, j) = 1 ;
        if(y.idx(j) < 6 * x.idx(i)) {
          a(i, j) = y.idx(j) ;
          b(i, j) = y.idx(j) ;
          c(i, j) = y.idx(j) ;
        }
        else {
          a(i, j) = 10 ;
          b(i, j) = 10 ;
          c(i, j) = 10 ;
        }
      } ALLOVER(j) ;
    } ALLOVER(i) ;

//  m(1, 6)  = .true.
//  m(1, 12) = .true.
//  m(1, 25) = .true.
//
//  m(3, 35) = .true.
//
//  m(4, 1)  = .true.
//  m(4, 2)  = .true.
//

    {
      Location s(x(0)) ;
      AT(s) {
	{
          Location t(y(5)) ;
	  AT(t) m(s, t) = 1 ; TA(t) ;
	}

	{
          Location t(y(11)) ;
	  AT(t) m(s, t) = 1 ; TA(t) ;
	}

	{
          Location t(y(25)) ;
	  AT(t) m(s, t) = 1 ; TA(t) ;
	}
      } TA(s) ;
    }
    
    {
      Location s(x(2)) ;
      AT(s) {
	{
          Location t(y(34)) ;
	  AT(t) m(s, t) = 1 ; TA(t) ;
	}
      } TA(s) ;
    }

    {
      Location s(x(3)) ;
      AT(s) {
	{
          Location t(y(0)) ;
	  AT(t) m(s, t) = 1 ; TA(t) ;
	}

	{
          Location t(y(1)) ;
	  AT(t) m(s, t) = 1 ; TA(t) ;
	}
      } TA(s) ;
    }

//  do j = 1, 35
//    m(5, j) = .true.
//  enddo

    Location s(x(4)) ;
    OVERALL(j) {
      m(s, j) = 1 ;
    } ALLOVER(j) ;

  } NO(q) ;

//  print "(6i4)", sum(a, dim = 2)
//  print "(6i4)", sum(a, dim = 2, mask = m)

  Array1<int> resa(x, q) ;

  sum(resa, a, 1) ;
  aprintf("%12d", resa) ;
  gprintf("\n") ;
  
  sum(resa, a, 1, m) ;
  aprintf("%12d", resa) ;
  gprintf("\n") ;

//  print "(6i4)", product(c, dim = 2)
//  print "(6i4)", product(c, dim = 2, mask = m)

  Array1<double> resc(x, q) ;

  product(resc, c, 1) ;
  aprintf("  %10e", resc) ;
  gprintf("\n") ;
  
  product(resc, c, 1, m) ;
  aprintf("  %10e", resc) ;
  gprintf("\n") ;

//  print "(6i4)", maxval(a, dim = 2)
//  print "(6i4)", maxval(a, dim = 2, mask = m)

  maxval(resa, a, 1) ;
  aprintf("%12d", resa) ;
  gprintf("\n") ;
  
  maxval(resa, a, 1, m) ;
  aprintf("%12d", resa) ;
  gprintf("\n") ;

//  print "(6i4)", minval(a, dim = 2)
//  print "(6i4)", minval(a, dim = 2, mask = m)

  minval(resa, a, 1) ;
  aprintf("%12d", resa) ;
  gprintf("\n") ;
  
  minval(resa, a, 1, m) ;
  aprintf("%12d", resa) ;
  gprintf("\n") ;

//  print "(6i4)", all(m, dim = 2)

  all(resa, m, 1) ;
  aprintf("%12d", resa) ;
  gprintf("\n") ;
  
//  print "(6i4)", any(m, dim = 2)

  any(resa, m, 1) ;
  aprintf("%12d", resa) ;
  gprintf("\n") ;
  
//  print "(6i4)", count(m, dim = 2)

  count(resa, m, 1) ;
  aprintf("%12d", resa) ;
  gprintf("\n") ;
  
//  print "(6i4)", maxloc(a, dim = 2)
//  print "(6i4)", maxloc(a, dim = 2, mask = m)

  Array1<int> loc(x, q) ;

  maxloc(resa, loc, a, 1) ;
  aprintf("%5d(%5d)", resa, loc) ;
  gprintf("\n") ;
  
  maxloc(resa, loc, a, 1, m) ;
  aprintf("%5d(%5d)", resa, loc) ;
  gprintf("\n") ;

//  print "(6i4)", minloc(a, dim = 2)
//  print "(6i4)", minloc(a, dim = 2, mask = m)

  minloc(resa, loc, a, 1) ;
  aprintf("%5d(%5d)", resa, loc) ;
  gprintf("\n") ;
  
  minloc(resa, loc, a, 1, m) ;
  aprintf("%5d(%5d)", resa, loc) ;
  gprintf("\n") ;

  AdlibFinalize() ;
}


// -------------------------------------------------------------
// Things to do
//

